package duc.util;

import java.awt.TextArea;
import java.awt.event.*;

/**
 * AwtTelexDriver - The driver for AWT's TextArea
 * @version	0.1
 * @author	Ho Ngoc Duc <duc@informatik.uni-leipzig.de>
 */
public class AwtTelexDriver extends AbstractTelexDriver
{
	protected TextArea input;
	public AwtTelexDriver(TextArea ta)
	{
	this(ta, TCVN3Encoding.getInstance());
	}
	public AwtTelexDriver(TextArea ta, Encoding enc)
	{
	input = ta;
	encoding = enc;
	}
	protected int getCaretPosition() { return input.getCaretPosition(); }
	protected String getText() { return input.getText(); }
   public void keyPressed(KeyEvent e)
   {
	   super.keyPressed(e);
	   modifyText(e);
   }   
	protected void replaceCharacter(int idx, char c)
	{
	input.replaceRange(""+c, idx, idx+1);
	}
	protected void setCaretPosition(int pos) { input.setCaretPosition(pos); }
	protected void setText(String str) { input.setText(str); }
}
