package duc.util;

import java.awt.*;
import java.awt.event.*;

public class Control extends Panel {

	AbstractTelexDriver owner;
	Choice from = new Choice();
	Choice to = new Choice();
	Button convert = new Button("Convert");
	Button undo = new Button("Undo");
	Encoding[] encodings = VnConvert.ENCODINGS;
	String originalText = "";

	class ConvertAction implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    originalText = owner.getText();
	    Encoding e1 = encodings[from.getSelectedIndex()];
	    Encoding e2 = encodings[to.getSelectedIndex()];
	    if (e1 == e2) return;
	    owner.setText(VnConvert.convert(owner.getText(), e1, e2));
	}
	}
	public Control(AbstractTelexDriver ta) {
	owner = ta;
	initialize();
	}
	private void initialize() {
	setLayout(new FlowLayout());
	originalText = owner.getText();
	for (int i=0; i<encodings.length; i++) {
	    from.add(encodings[i].getID());
	    to.add(encodings[i].getID());
	}
	add(convert);
	add(new Label("From:"));
	add(from);
	add(new Label("To:"));
	add(to);
	convert.addActionListener(new ConvertAction());
	undo.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		owner.setText(originalText);
	    }
	});
	add(undo);
	}
}
