package duc.util;

public final class VIQREncoding extends MultipleByteEncoding
{
	private static String[] myDD = {"Dd", "dd"};

	private static String[] myHND = {
	"A","A`","A?","A~","A'","A.","A(","A(`","A(?","A(~","A('","A(.",
	"A^","A^`","A^?","A^~","A^'","A^.","E","E`","E?","E~","E'","E.",
	"E^","E^`","E^?","E^~","E^'","E^.","I","I`","I?","I~","I'","I.",
	"O","O`","O?","O~","O'","O.","O^","O^`","O^?","O^~","O^'","O^.",
	"O+","O+`","O+?","O+~","O+'","O+.","U","U`","U?","U~","U'","U.",
	"U+","U+`","U+?","U+~","U+'","U+.","Y","Y`","Y?","Y~","Y'","Y.",
	"a","a`","a?","a~","a'","a.","a(","a(`","a(?","a(~","a('","a(.",
	"a^","a^`","a^?","a^~","a^'","a^.","e","e`","e?","e~","e'","e.",
	"e^","e^`","e^?","e^~","e^'","e^.","i","i`","i?","i~","i'","i.",
	"o","o`","o?","o~","o'","o.","o^","o^`","o^?","o^~","o^'","o^.",
	"o+","o+`","o+?","o+~","o+'","o+.","u","u`","u?","u~","u'","u.",
	"u+","u+`","u+?","u+~","u+'","u+.","y","y`","y?","y~","y'","y."
	};

	public static String ID = "VIQR";
	private static Encoding instance = new VIQREncoding(myDD, myHND);
	private VIQREncoding(String[] DD, String[] HND) {
		super(DD, HND);
	}
private char compose(Encoding e, char orig, char modifier) {
	switch (modifier) {
		case 'd' :
		case 'D' :
			{
				return e.addStroke(orig);
			}
		case '^' :
			{
				return e.addCircumflex(orig);
			}
		case '(' :
		case '<' :
		case '+' :
		case '*' :
			{
				return e.addBreveHorn(orig);
			}
		case '`' :
			{
				return e.modifyTone(orig, Encoding.HUYEN);
			}
		case '?' :
			{
				return e.modifyTone(orig, Encoding.HOI);
			}
		case '~' :
			{
				return e.modifyTone(orig, Encoding.NGA);
			}
		case '\'' :
			{
				return e.modifyTone(orig, Encoding.SAC);
			}
		case '.' :
			{
				return e.modifyTone(orig, Encoding.NANG);
			}
		default :
			{
				return orig;
			}
	}
}
/**
 * fromTCVN1 method comment.
 */
public java.lang.String fromTCVN1(java.lang.String str) {
	String[] table = getFROM_TCVN1();
	StringBuffer sb = new StringBuffer(str.length());
	boolean needEscape = false;
	char c;
	for (int i = 0; i < str.length(); i++){
		c = str.charAt(i);
		if (needEscape && (c == '.' || c == '?')) {
			sb.append('\\');
		}
		sb.append(table[c]);
		needEscape = TCVN1Encoding.getInstance().isVowel(c);
	}
	return sb.toString();
}
	public String getID() { return ID; }
	public static Encoding getInstance() {
	return instance;
	}
public java.lang.String toTCVN1(java.lang.String str) {
	StringBuffer sb = new StringBuffer(str.length());
	Encoding e = TCVN1Encoding.getInstance();
	if (str.length() <= 1)
		return str;
	char c = str.charAt(0);
	char nc, mc;
	for (int i = 1; i < str.length(); i++) {
		nc = str.charAt(i);
		if ((c == '\\') && (nc == '.' || nc == '?')) {
			c = nc;
		} else {
			mc = compose(e, c, nc);
			if (mc == c) {
				sb.append(c);
				c = nc;
			}
			else c = mc;
		}
	}
	sb.append(c);
	return sb.toString();
}
}
