package duc.util;

import java.util.*;
import java.io.*;

public class VnConvert
{
	protected static Hashtable h = new Hashtable(11);
	public static Encoding[] ENCODINGS = {
		BKHCM1Encoding.getInstance(),
		BKHCM2Encoding.getInstance(),
		CCC25Encoding.getInstance(),
		CCC30Encoding.getInstance(),
		CP1129Encoding.getInstance(),
		CP1258Encoding.getInstance(),
		FreeCodeEncoding.getInstance(),
		TCVN1Encoding.getInstance(),
		TCVN2Encoding.getInstance(),
		TCVN3Encoding.getInstance(),
		TCVN2BEncoding.getInstance(),
		ThinARTMacEncoding.getInstance(),
		ThinARTWinEncoding.getInstance(),
		VietKeyEncoding.getInstance(),
		VietSeaEncoding.getInstance(),
		VietStarEncoding.getInstance(),
		VietWareFEncoding.getInstance(),
		VietWareXEncoding.getInstance(),
		VIQREncoding.getInstance(),
		VISCIIEncoding.getInstance(),
		VISCIIMacEncoding.getInstance(),
		VISCIIWinEncoding.getInstance(),
		VniANSIEncoding.getInstance(),
		VniASCIIEncoding.getInstance(),
		VniDOSEncoding.getInstance(),
		VNIEncoding.getInstance(),
		VniJEncoding.getInstance(),
		VniMailEncoding.getInstance(),
		VnuDOSEncoding.getInstance(),
		VnuWinEncoding.getInstance(),
		VPSEncoding.getInstance(),
		VPSMacEncoding.getInstance(),
	};

	static {
	initialize();
	}
	
public static String convert(String str, Encoding fromEnc, Encoding toEnc) {
	return toEnc.fromTCVN1(fromEnc.toTCVN1(str));
}
public static String convert(String str, Hashtable d) {
	int max = 1;
	Enumeration e = d.keys();
	String s = str;
	while (e.hasMoreElements())
		max = Math.max(max, ((String) e.nextElement()).length());
	for (int i = 0; i < max - 1; i++) {
		s = s + " ";
	}
	StringBuffer sb = new StringBuffer(s.length());
	String key = "";
	boolean found;
	int i = 0;
	int k;
	while (i < str.length()) {
		found = false;
		k = max;
		while (k > 0 && !found) {
			key = s.substring(i, i + k);
			if (d.containsKey(key))
				found = true;
			else
				k--;
		}
		if (found) {
			sb.append(d.get(key));
			for (int j = 0; j < k; j++){
				i++;
			}
		}
		else {
			sb.append(s.charAt(i));
			i++;
		}
	}
	return sb.toString();
}
private static void initialize() {
	for (int i = 0; i < ENCODINGS.length; i++){
		Encoding e = ENCODINGS[i];
		h.put(e.getID().toLowerCase(), e);
	}
}
public static void main(String[] args) throws IOException {
	if (args.length != 4) {
		usage();
		System.exit(1);
	}
	Encoding e1 = (Encoding) h.get(args[0].toLowerCase());
	Encoding e2 = (Encoding) h.get(args[2].toLowerCase());
	if (e1 == e2) {
		System.out.println("Same encoding. Nothing to do!");
		System.exit(0);
	}
	byte[] bytearr = new byte[1024];
	int len = 0;
	String line;
	BufferedReader input = new BufferedReader(new FileReader(args[1]));
	PrintWriter output = new PrintWriter(new FileWriter(args[3], true));
	try {
		while ((line = input.readLine()) != null) {
			try {
				output.println(convert(line, e1, e2));
			} catch (Exception e) {
			}
		}
	} finally {
		input.close();
		output.close();
	}
}
private static void usage() {
	System.out.println("Usage: VnConvert in-encoding in out-encoding out");
	System.out.println("E.g., VnConvert tcvn3 test.vn3 vni test.vni");
	System.out.println("in-encoding and out-encoding can be (case-insensitive):");
	for (int i = 0; i < ENCODINGS.length; i++) {
		System.out.println(ENCODINGS[i].getID());
	}
}
}
