package vietdict.common;

/**
 * LV2Latin1.java
 *
 *
 * Created: Wed Aug 16 13:14:42 2000
 *
 * @author 
 * @version
 */

public class LV2Latin1  {

    static int[] Lv2Lat, Lat2Lv;

    static {
	initialize();
    }

    private static void initialize() {
	Lat2Lv = new int[256];
	for (int i = 0; i < 256; i++) {
		Lat2Lv[i] = i;
	}
	Lat2Lv[224] = 181; // a`
	Lat2Lv[225] = 184; // a'
	Lat2Lv[226] = 169; // a^
	Lat2Lv[231] = 7; // c cedilla
	Lat2Lv[232] = 204; // e`
	Lat2Lv[233] = 208; // e'
	Lat2Lv[234] = 170; // e^
	Lat2Lv[235] = 132; // e"
	Lat2Lv[236] = 215; // i`
	Lat2Lv[237] = 221; // i'
	Lat2Lv[238] = 134; // i^
	Lat2Lv[239] = 133; // i"
	Lat2Lv[242] = 223; // o`
	Lat2Lv[243] = 227; // o'
	Lat2Lv[244] = 171; // o^
	Lat2Lv[249] = 239; // u`
	Lat2Lv[250] = 243; // u'
	Lat2Lv[251] = 137; // u^

	Lv2Lat = new int[256];
	for (int i = 0; i < 256; i++) {
		Lv2Lat[Lat2Lv[i]] = i;
	}
    }

    public static byte[] convertLV2LAT(byte[] orig) {
	byte[] ret = new byte[orig.length];
	for (int i=0; i<ret.length; i++) {
	    ret[i] = (byte)Lv2Lat[orig[i] & 0xff];
	}
	return ret;
    }

    public static String convertLV2LAT(String s) {
	return new String(convertLV2LAT(s.getBytes()));
    }
    
    public static byte[] convertLAT2LV(byte[] orig) {
	byte[] ret = new byte[orig.length];
	for (int i=0; i<ret.length; i++) {
	    ret[i] = (byte)Lat2Lv[orig[i] & 0xff];
	}
	return ret;
    }
    
    public static String convertLAT2LV(String s) {
	return new String(convertLAT2LV(s.getBytes()));
    }
    
    public LV2Latin1() {
	
    }
    
} // LV2Latin1
