package vietdict.common;

/**
 * LVCollator.java
 *
 *
 * Created: Tue May 16 10:19:34 2000
 *
 * @author 
 * @version
 */

import duc.util.*;
import java.util.*;
import java.io.*;

//public class LVCollator implements Comparable {
public class LVCollator {
	
	public static int[] LV = new int[256];

	static {
	initialize();
	}

	private static int circOffset(char c, int acc) {
	if (c == 'a') return 100 * c + 60 + 2 * acc;
	else return 100 * c + 40 + 2 * acc;
	}
	public static int compare(byte[] arr1, byte[] arr2) {
	return compare(arr1, arr2, LV);
	}
public static int compare(byte[] arr1, byte[] arr2, int[] t) {
	int len = Math.min(arr1.length, arr2.length);
	int i = 0, j = 0;
	int b1, b2;
	while (len-- != 0) {
		b1 = t[arr1[i++] & 0xff];
		b2 = t[arr2[j++] & 0xff];
		if (b1 != b2) {
			return b1 - b2;
		}
	}
	return arr1.length - arr2.length;
}
	public static int compare(String s1, String s2) {
	return compare(s1.getBytes(), s2.getBytes());
	}
	private static int hornOffset(char c, int acc) {
	if (c == 'a') return 100 * c + 40 + 2 * acc;
	else return 100 * c + 60 + 2 * acc;
	}
private static void initialize() {
	for (int i = 0; i < 128; i++) {
		LV[i] = 100 * Character.toLowerCase((char) i);
	}
	for (int i = 128; i < 256; i++) {
		LV[i] = 100 * i;
	}
	Encoding e = TCVN3Encoding.getInstance();
	char[] base = {'a', 'e', 'i', 'o', 'u', 'y'};
	char c;
	for (int k = 0; k < base.length; k++) {
		c = base[k];
		for (int i = 1; i < 6; i++) {
			LV[e.modifyTone(c, i)] = (100 * base[k]) + 20 + (2 * i);
		}
		c = e.addBreveHorn(base[k]);
		if (c != base[k]) {
			for (int i = 0; i < 6; i++) {
				LV[e.modifyTone(c, i)] = hornOffset(base[k], i);
			}
		}
		c = e.addCircumflex(base[k]);
		if (c != base[k]) {
			for (int i = 0; i < 6; i++) {
				LV[e.modifyTone(c, i)] = circOffset(base[k], i);
			}
		}
	}
	LV[130] = 100 * 'a' + 50; // 50 = Umlaut

	LV[7] = 100 * 'c' + 10; // {,c}
	LV[174] = 100 * 'd' + 10; // {dd}
	LV[143] = 100 * 'n' + 10; // {~n}
	LV[132] = 100 * 'e' + 50;
	LV[134] = 100 * 'i' + 40; // 40 = circumflex
	LV[133] = 100 * 'i' + 50;
	LV[136] = 100 * 'o' + 50;
	LV[137] = 100 * 'u' + 40;
	LV[129] = 100 * 'u' + 50;
	//{A( = a(, A^ = a^, E^ = e^, O^ = o^, O+ = o+, U+ = u+, DD = dd}
	for (int i = 161; i < 168; i++) {
		LV[i] = LV[i + 7];
	}
}
} // LVCollator
