package vietdict.common;

import java.util.*;

public class Meaning 
{
	
	String translation; // meaning of the word or phrase
	Vector examples = new Vector();
	public static String BEGIN = "-";
	
public Meaning(String translation) {
	this.translation = translation;
}
public void addExample(Example example) {
	examples.addElement(example);
}
public String toHtml(String base) {
	StringBuffer sb = new StringBuffer();
	sb.append("\n    <LI> ");
	String aString = translation;
	int linkIndex = aString.indexOf(Parser.LINK);
	if (linkIndex >= 0) {
		sb.append(aString.substring(0, linkIndex));
		String linkable;
		int lastLinkIndex = aString.lastIndexOf(Parser.LINK);
		if (lastLinkIndex > linkIndex) {
			linkable = aString.substring(linkIndex, lastLinkIndex);
			sb.append(Parser.insertLinks(linkable, base));
			sb.append(aString.substring(lastLinkIndex + 1));
		} else {
			linkable = aString.substring(linkIndex);
			sb.append(Parser.insertLinks(linkable, base));
		}
	} else {
		sb.append(aString);
	}
	if (examples.size() > 0) {
		sb.append("\n      <UL>");
		for (int i = 0; i < examples.size(); i++) {
			Example ex = (Example) examples.elementAt(i);
			sb.append(ex.toHtml(base));
		}
		sb.append("\n      </UL>");
	}
	return sb.toString();
}
public String toString() {
	String out = "\n" + BEGIN + " " + translation;
	for (int i = 0; i < examples.size(); i++) {
		Example ex = (Example) examples.elementAt(i);
		out = out + ex.toString(); // ex.toString() begins with new line
	}
	return out;
}
}
