package vietdict.common;

import java.util.*;

public class WordKind implements MeaningContainer 
{

	String type;
	Vector meanings = new Vector();
	Vector idioms = new Vector(); // Vector of idiomatic usages
	public static String BEGIN = "*";

public void addIdiom(Idiom idiom) {
	idioms.addElement(idiom);
}
public void addMeaning(Meaning meaning) {
	meanings.addElement(meaning);
}
protected void printTypeAsHtml(StringBuffer sb, String base) {
	sb.append("\n<H3> ");
	sb.append(type);
	sb.append(" </H3>");
}
public String toHtml(String base) {
	StringBuffer sb = new StringBuffer();
	int i;
	printTypeAsHtml(sb, base);
	sb.append("\n  <UL>");
	for (i = 0; i < meanings.size(); i++) {
		sb.append(((Meaning) meanings.elementAt(i)).toHtml(base));
	}
	sb.append("\n  </UL>");
	if (idioms.size() != 0) {
		sb.append("\n  <H4>Idioms</H4>");
		sb.append("\n    <OL>");
		for (i = 0; i < idioms.size(); i++) {
			Idiom anIdiom = (Idiom) idioms.elementAt(i);
			sb.append(anIdiom.toHtml(base));
		}
		sb.append("\n    </OL>");
	}
	return sb.toString();
}
public String toString() {
	StringBuffer sb = new StringBuffer();
	int i;
	sb.append("\n" + BEGIN + " ");
	sb.append(type);
	for (i = 0; i < meanings.size(); i++) {
		sb.append(((Meaning) meanings.elementAt(i)).toString());
	}
	for (i = 0; i < idioms.size(); i++) {
		Idiom anIdiom = (Idiom) idioms.elementAt(i);
		sb.append(anIdiom.toString());
	}
	return sb.toString();
}
}
