package vietdict.netutil;

import java.util.*;
import java.io.*;

public class HttpParser {

	/**
	 * Translates String from x-www-form-urlEncoded format into text.
	 * @param s String to be translated
	 * @return the translated String.
	 */
	public static String decode(String s) 
	{
		ByteArrayOutputStream out = new ByteArrayOutputStream(s.length());
		
		for (int i = 0; i < s.length(); i++) 
		{
			char c = s.charAt(i);
			if (c == '+') 
			{
				out.write(' ');
			}
			else if (c == '%') 
			{
				int c1 = Character.digit(s.charAt(++i), 16);
				int c2 = Character.digit(s.charAt(++i), 16);
				out.write((char) (c1 * 16 + c2));
			}
			else 
			{
				out.write(c);
			}
		} // end for
		
		return out.toString();
		
	}
	/**
	 * Parse a CGI query string to get the parameters sent by the client.
	 * @param s String to be parsed
	 * @return the dictionary of key-value pairs.
	 */
	public static Properties parseQuery(String s)
	{
		return parseQuery(s, "&", "=");
	}
	public static Properties parseQuery(String s, String delim, String rel)
	{
		java.util.Properties result = new java.util.Properties();
		StringTokenizer st = new StringTokenizer(s, delim);
		String current, key, value;
		int sep = 0;
		while (st.hasMoreTokens()) 
		{
			current = st.nextToken();
			sep = current.indexOf(rel);
			if (sep == -1) sep = 0;
			key = decode(current.substring(0, sep));
			value = decode(current.substring(sep+1));
			result.put(key,value);
			//System.out.println(key+" = "+value);
		}
		return result;
	}
}
