package vietdict.netutil;

import java.io.*;
import java.util.*;

public class NetToolkit
{

	protected static Properties ContentTypes = new Properties();
	
	/**
	 * Guess the content type of a file with a certain ending
	 * @param  suffix  the file ending
	 * @return the content type (default is text/plain) 
	 */
	public static String getContentTypeForName(String suffix)
	{
		return ContentTypes.getProperty(suffix, "text/plain");
	}
	public static Properties getContentTypes()
	{
		return ContentTypes;
	}
	public static void printHTTPHeader(PrintWriter printwriter,
												String message,
												String svr,
												int len,
												String type)
	{
		printwriter.print("HTTP/1.0 " + message);
		Date date = new Date();
		printwriter.print("\r\nDate: " + date);
		printwriter.print("\r\nServer: ");
		printwriter.print(svr);
		if (len >= 0) printwriter.print("\r\nContent-length: " + len);
		printwriter.print("\r\nContent-type: ");
		printwriter.print(type);
		printwriter.print("\r\n\r\n");
	}
	public static void setContentTypes(Properties prop)
	{
		ContentTypes = prop;
	}
}
