package vietdict.server;

import vietdict.netutil.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class DictWebServerThread extends WebServerThread 
{		

	protected void execute(PrintWriter os, String programName, Properties paramDict, String version)
	{
		String word = paramDict.getProperty("word","a");
		String format = paramDict.getProperty("fmt","8");
		int db = Integer.parseInt(paramDict.getProperty("db","4"));
		MultiDictEngine engine = MultiDictEngine.getDefault();
		String res=engine.getReply(programName, format, db, word, 20);
		String header="<HTML>\n<HEAD><TITLE>"+word+"</TITLE>\n<LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\""+engine.cssLink+"\">\n</HEAD>\n<BODY>\n";
		String footer = "\n</BODY></HTML>";
		int len = res.length() + header.length() + footer.length();
		String ct = "text/html";
		if (version.startsWith("HTTP/"))
		{
			NetToolkit.printHTTPHeader(os,"200 OK",getVersion(),len,ct);
		}
		os.print(header);
		os.print(res);
		os.print(footer);
	}
	protected String getVersion()
	{
		return "Ho Ngoc Duc's Dictionary Server, 10/1999";
	}
	protected void serve(PrintWriter os, String method, String version)
	{
		MultiDictEngine engine = MultiDictEngine.getDefault();
		String res = engine.getReply(MultiDictEngine.EV,method,20,true,false,"");
		os.println(vietdict.common.VSDictEntry.toVIQRString(res));
	}
	/**
	 * process a CGI query
	 * @param  os The output stream
	 * @param  query  The CGI query: programName?para1=val1&...&para2=val2
	 * @param  version  The protocol version
	 */
	 
	protected void serveCGI(PrintWriter os, String query, String version)
	{
		int idx = query.indexOf('?');
		String programName = query.substring(0, idx);
		String param = query.substring(idx+1);
		Properties paramDict = HttpParser.parseQuery(param);
		execute(os, programName, paramDict, version);
	}
	protected void serveGET(PrintWriter os, String file, String version)
	{
	    //System.out.println(file);
		if (file.indexOf('?') == -1)
		{
			// Not a CGI query, invoke method of superclass
			super.serveGET(os, file, version);
		}
		else
		{
			serveCGI(os, file, version);
		}
	}
}
