package vietdict.server;

import vietdict.netutil.*;
import java.net.*;
import java.util.*;
import java.io.*;

public class HNDWebServer
{
	static String getIniFileName()
	{
	return "httpserver.properties";
	}
	private static String getLogFileName()
	{
		return "webserver.log";
	}
public static void log(String msg, String file) {
	try {
		RandomAccessFile out = new RandomAccessFile(file, "rw");
		out.seek(out.length());
		out.writeBytes(msg);
		out.writeByte('\n');
		out.close();
	} catch (Throwable t) {
	}
}
public static void main(String args[]) {
    InputStream in;
    StringBuffer msg = new StringBuffer(new Date().toString());
    try {
	if (args.length > 0) {
	    in = new FileInputStream(args[0]);
	} else {
	    in = HNDWebServer.class.getResourceAsStream(getIniFileName());
	}
	Properties prop = new Properties();
	prop.load(in);
	NetToolkit.setContentTypes(prop);
	in.close();
	int port = Integer.parseInt(prop.getProperty("port", "8080"));
	try {
	    Socket s = new Socket("localhost",port);
	    msg.append("\nServer currently running at "+port);
	    return;
	} catch (Exception e) {
	    msg.append("\nStart server at port "+port);
	}
	int backlog = Integer.parseInt(prop.getProperty("backlog", "8"));
	String rootDir = prop.getProperty("httproot", ".");
	String threadClassName = prop.getProperty("threadClass", "vietdict.server.DictWebServerThread");
	ServerSocket svrSocket = new ServerSocket(port, backlog);
	MultiDictEngine.setDefault(new MultiDictEngine(prop));
	msg.append("\nRun in ").append(rootDir).append(" at " + port);
	log(msg.toString(), getLogFileName());
	while (true) {
	    Socket clientSocket = svrSocket.accept();
	    Class threadClass = Class.forName(threadClassName);
	    WebServerThread j = (WebServerThread) threadClass.newInstance();
	    j.initialize(clientSocket, rootDir);
	    j.start();
	}
    } catch (Exception ioexception) {
	ioexception.printStackTrace();
	System.exit(-1);
    } finally {
	msg.append(". Stop at "+new Date());
	log(msg.toString(), getLogFileName());
    }
}
}
