package vietdict.server;

import java.io.ByteArrayOutputStream;
import java.util.StringTokenizer;
/**
 * Insert the type's description here.
 * Creation date: (24.07.00 14:52:12)
 * @author: Administrator
 */
public class MemoryEngine extends Engine {
	byte[] data;
/**
 * Insert the method's description here.
 * Creation date: (24.07.00 14:53:34)
 * @param data byte[]
 */
public MemoryEngine(byte[] data) throws java.io.IOException {
	this.data = data;
	initialize();
}
/**
 * getDataSource method comment.
 */
protected RandomAccessDataSource getDataSource() throws java.io.IOException {
	return new MemoryDataSource(this.data);
}
public String getReply(String s, int i, boolean t, boolean h, String b) {
	return getReply(s, i, t, h, b, "a".getBytes(), "zz".getBytes());
}
String getReply(String s, int i, boolean t, boolean h, String b, byte[] last, byte[] next) {
	try {
		RandomAccessDataSource f = getDataSource();
		java.io.ByteArrayOutputStream out = new java.io.ByteArrayOutputStream();
		int j = getPosition(s.getBytes(), f);
		byte[] buf = getEntry(j, f);
		f.close();
		out.write(buf, 1, buf.length-1); // ignore @ at the beginning
		String ret = out.toString();
		if (h) {
			ret = makeLink(ret, s, b);
		};
		out.reset();
		byte[] sep = " | ".getBytes();
		byte[] base = b.getBytes();
		out.write("\n<hr>\n".getBytes());
		int pos = j-i/2;
		if (pos < 0) {
			writeKey(last, base, out, h);
			out.write(sep);
		}
		for (int k = Math.max(0, pos); k < Math.min(pos+i, keys.length-1); k++){
			writeKey(readKey(k, f), base, out, h);
			out.write(sep);
		}
		if (pos + i > keys.length-1) {
			writeKey(next, base, out, h);
		}
		return ret + out.toString();
	} catch (Exception e) {
		return e.toString();
	}
}
private boolean isBOL(String token) {
	if (token.endsWith(":") && Character.isDigit(token.charAt(0))) return true;
	if (token.equals("n") || token.equals("v")) return true;
	if (token.equals("adj") || token.equals("adv")) return true;
	return false;
}
private String makeLink(String line, String word, String base) {
	if (line == null | line.length() < 2) return line;
	StringTokenizer st = new StringTokenizer(line, " ,;!?()[]{}\"'`\t\n\r\f", true); // period not always a delimiter: etc., e.g.
	StringBuffer sb = new StringBuffer(word.length());
	String s;
	while (st.hasMoreTokens()) {
		s = st.nextToken();
		if (isBOL(s)) {
			sb.append("<p>");
		}
		if ((s.length() > 1) && !s.equals(word)) {
			sb.append("<a href=\"");
			sb.append(base);
			sb.append(s);
			sb.append("\">");
			sb.append(s);
			sb.append("</a>");
		}
		else {
			sb.append(s);
		}
	}
	return sb.toString();
}
private void writeKey(byte[] s, byte[] base, ByteArrayOutputStream out, boolean link) throws java.io.IOException {
	if (link) {
		for (int i = 0; i < s.length; i++){
			if (s[i] == ' ') {
				s[i] = (byte)'_';
			}
		}
		out.write("<a href=\"".getBytes());
		out.write(base);
		out.write(s);
		out.write("\">".getBytes());
		out.write(s);
		out.write("</a>".getBytes());
	} else {
		out.write(s);
	}
}
}
