package vietdict.server;

import java.io.*;
import com.sun.java.util.collections.*;
import java.io.IOException;
import java.util.zip.*;
/**
 * Insert the type's description here.
 * Creation date: (25.07.00 14:04:31)
 * @author: Administrator
 */
public class ZipEngine extends Engine {
	String zipFile;
	ArrayList firstKeys;
	PageInfo fPage = new PageInfo();
	MemoryEngine fEngine;
/**
 * Insert the method's description here.
 * Creation date: (25.07.00 14:11:55)
 * @param zipFile java.lang.String
 */
public ZipEngine(String zipFile) throws IOException {
	this.zipFile = zipFile;
	initialize();
}
/**
 * getReply method comment.
 */
public String getReply(String s, int i, boolean t, boolean h, String b) {
	fPage.firstKey = s.getBytes();
	int pos = Collections.binarySearch(firstKeys, fPage);
	int size = firstKeys.size();
	if (pos < 0) {
		pos = -pos - 2;
	}
	if (pos < 0) {
		return "Not found!";
	}
	fEngine.keys = ((PageInfo) firstKeys.get(pos)).keys;
	ZipFile f = null;
	try {
		f = new ZipFile(this.zipFile);
		ZipEntry ze = f.getEntry(getZipEntryName(pos));
		fEngine.data = readZipEntry(f.getInputStream(ze));
		byte[] prev = ((PageInfo) firstKeys.get((pos+size-1)%size)).lastKey;
		byte[] next = ((PageInfo) firstKeys.get((pos+size+1)%size)).firstKey;
		return fEngine.getReply(s, i, t, h, b, prev, next);
	} catch (IOException ioe) {
		return ioe.toString();
	} finally {
		if (f != null) {
			try {
				f.close();
			} catch (IOException ex) {
			}
		}
	}
}
String getZipEntryName(int i) {
	return ""+i+".txt";
}
protected void initialize() throws IOException {
	ZipFile f = null;
	try {
		f = new ZipFile(this.zipFile);
		ZipEntry ze = null;
		PageInfo p = null;
		RandomAccessDataSource ds;
		InputStream is;
		Hashtable h = new Hashtable();
		for (java.util.Enumeration e = f.entries(); e.hasMoreElements();) {
			ze = (ZipEntry) e.nextElement();
			p = new PageInfo();
			try {
				is = f.getInputStream(ze);
				fEngine = new MemoryEngine(readZipEntry(is));
			} catch (IOException ioe) {
				System.out.println("Error reading " + ze.getName());
			}
			p.keys = fEngine.keys;
			ds = fEngine.getDataSource();
			p.firstKey = fEngine.readKey(0, ds);
			p.lastKey = fEngine.readKey(p.keys.length-1, ds);
			h.put(ze.getName(), p);
		}
		firstKeys = new ArrayList(h.size());
		for (int i = 0; i < h.size(); i++) {
			firstKeys.add(h.get(getZipEntryName(i)));
		}
		f.close();
	} catch (IOException ex) {
		System.out.println(ex.toString());
	} finally {
		if (f != null) {
			try {
				f.close();
			} catch (IOException ioe) {
			}
		}
	}
}
protected byte[] readZipEntry(InputStream is) throws IOException {
	byte[] buff = new byte[2048];
	int len = 0;
	ByteArrayOutputStream out = new ByteArrayOutputStream();
	while ((len = is.read(buff)) != -1) {
		out.write(buff, 0, len);
	}
	is.close();
	return out.toByteArray();
}
}
